#pragma once

#include "CoreMinimal.h"
#include "CoreBaseUserWidget.h"
#include "Templates/SubclassOf.h"
#include "ToastNotificationViewData.h"
#include "CoreLobbyPlayWhileYouWaitWidget.generated.h"

class UDBDImage;
class UDBDRichTextBlock;
class UCoreKeyListenerButtonWidget;
class UCoreToggleButtonWidget;
class UCoreButtonWidget;

UCLASS(Blueprintable, EditInlineNew)
class UCoreLobbyPlayWhileYouWaitWidget : public UCoreBaseUserWidget
{
	GENERATED_BODY()

public:
	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDImage* Icon;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDRichTextBlock* Title;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDRichTextBlock* SubTitle;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDRichTextBlock* Description;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreKeyListenerButtonWidget* InteractButton;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreToggleButtonWidget* OpenButton;

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UCoreKeyListenerButtonWidget> ButtonWidgetClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FString InputBlockerId;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FText _tooltipText;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FText _subTitleText;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FText _descriptionText;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _isShowingContent;

private:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	FToastNotificationViewData _playWhileYouWaitData;

public:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void UpdateScaleformInputBlocker();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void SetVisuals(const FToastNotificationViewData& toastData, const bool isInteractable, const bool isNeedSubTitle);

private:
	UFUNCTION(BlueprintCallable)
	void OnOpenButtonClicked(UCoreButtonWidget* button);

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void OnInteractButtonClicked(UCoreButtonWidget* button);

private:
	UFUNCTION(BlueprintCallable)
	void OnButtonClicked(const int32 buttonId);

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void ChangeVisibility(bool isVisible);

public:
	UCoreLobbyPlayWhileYouWaitWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCoreLobbyPlayWhileYouWaitWidget) { return 0; }
